(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
  typeof define === 'function' && define.amd ? define('@foblex/drag-toolkit', ['exports'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.foblex = global.foblex || {}, global.foblex["drag-toolkit"] = {})));
})(this, (function (exports) { 'use strict';

  /******************************************************************************
  Copyright (c) Microsoft Corporation.

  Permission to use, copy, modify, and/or distribute this software for any
  purpose with or without fee is hereby granted.

  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
  REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
  AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
  INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
  LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
  OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
  PERFORMANCE OF THIS SOFTWARE.
  ***************************************************************************** */
  /* global Reflect, Promise, SuppressedError, Symbol, Iterator */
  var extendStatics = function (d, b) {
      extendStatics = Object.setPrototypeOf ||
          ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
          function (d, b) { for (var p in b)
              if (Object.prototype.hasOwnProperty.call(b, p))
                  d[p] = b[p]; };
      return extendStatics(d, b);
  };
  function __extends(d, b) {
      if (typeof b !== "function" && b !== null)
          throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
      extendStatics(d, b);
      function __() { this.constructor = d; }
      d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  }
  var __assign = function () {
      __assign = Object.assign || function __assign(t) {
          for (var s, i = 1, n = arguments.length; i < n; i++) {
              s = arguments[i];
              for (var p in s)
                  if (Object.prototype.hasOwnProperty.call(s, p))
                      t[p] = s[p];
          }
          return t;
      };
      return __assign.apply(this, arguments);
  };
  function __rest(s, e) {
      var t = {};
      for (var p in s)
          if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
              t[p] = s[p];
      if (s != null && typeof Object.getOwnPropertySymbols === "function")
          for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
              if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                  t[p[i]] = s[p[i]];
          }
      return t;
  }
  function __decorate(decorators, target, key, desc) {
      var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
      if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
          r = Reflect.decorate(decorators, target, key, desc);
      else
          for (var i = decorators.length - 1; i >= 0; i--)
              if (d = decorators[i])
                  r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
      return c > 3 && r && Object.defineProperty(target, key, r), r;
  }
  function __param(paramIndex, decorator) {
      return function (target, key) { decorator(target, key, paramIndex); };
  }
  function __esDecorate(ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
      function accept(f) { if (f !== void 0 && typeof f !== "function")
          throw new TypeError("Function expected"); return f; }
      var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
      var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
      var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
      var _, done = false;
      for (var i = decorators.length - 1; i >= 0; i--) {
          var context = {};
          for (var p in contextIn)
              context[p] = p === "access" ? {} : contextIn[p];
          for (var p in contextIn.access)
              context.access[p] = contextIn.access[p];
          context.addInitializer = function (f) { if (done)
              throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
          var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
          if (kind === "accessor") {
              if (result === void 0)
                  continue;
              if (result === null || typeof result !== "object")
                  throw new TypeError("Object expected");
              if (_ = accept(result.get))
                  descriptor.get = _;
              if (_ = accept(result.set))
                  descriptor.set = _;
              if (_ = accept(result.init))
                  initializers.unshift(_);
          }
          else if (_ = accept(result)) {
              if (kind === "field")
                  initializers.unshift(_);
              else
                  descriptor[key] = _;
          }
      }
      if (target)
          Object.defineProperty(target, contextIn.name, descriptor);
      done = true;
  }
  ;
  function __runInitializers(thisArg, initializers, value) {
      var useValue = arguments.length > 2;
      for (var i = 0; i < initializers.length; i++) {
          value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
      }
      return useValue ? value : void 0;
  }
  ;
  function __propKey(x) {
      return typeof x === "symbol" ? x : "".concat(x);
  }
  ;
  function __setFunctionName(f, name, prefix) {
      if (typeof name === "symbol")
          name = name.description ? "[".concat(name.description, "]") : "";
      return Object.defineProperty(f, "name", { configurable: true, value: prefix ? "".concat(prefix, " ", name) : name });
  }
  ;
  function __metadata(metadataKey, metadataValue) {
      if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
          return Reflect.metadata(metadataKey, metadataValue);
  }
  function __awaiter(thisArg, _arguments, P, generator) {
      function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
      return new (P || (P = Promise))(function (resolve, reject) {
          function fulfilled(value) { try {
              step(generator.next(value));
          }
          catch (e) {
              reject(e);
          } }
          function rejected(value) { try {
              step(generator["throw"](value));
          }
          catch (e) {
              reject(e);
          } }
          function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
          step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
  }
  function __generator(thisArg, body) {
      var _ = { label: 0, sent: function () { if (t[0] & 1)
              throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
      return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
      function verb(n) { return function (v) { return step([n, v]); }; }
      function step(op) {
          if (f)
              throw new TypeError("Generator is already executing.");
          while (g && (g = 0, op[0] && (_ = 0)), _)
              try {
                  if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                      return t;
                  if (y = 0, t)
                      op = [op[0] & 2, t.value];
                  switch (op[0]) {
                      case 0:
                      case 1:
                          t = op;
                          break;
                      case 4:
                          _.label++;
                          return { value: op[1], done: false };
                      case 5:
                          _.label++;
                          y = op[1];
                          op = [0];
                          continue;
                      case 7:
                          op = _.ops.pop();
                          _.trys.pop();
                          continue;
                      default:
                          if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                              _ = 0;
                              continue;
                          }
                          if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                              _.label = op[1];
                              break;
                          }
                          if (op[0] === 6 && _.label < t[1]) {
                              _.label = t[1];
                              t = op;
                              break;
                          }
                          if (t && _.label < t[2]) {
                              _.label = t[2];
                              _.ops.push(op);
                              break;
                          }
                          if (t[2])
                              _.ops.pop();
                          _.trys.pop();
                          continue;
                  }
                  op = body.call(thisArg, _);
              }
              catch (e) {
                  op = [6, e];
                  y = 0;
              }
              finally {
                  f = t = 0;
              }
          if (op[0] & 5)
              throw op[1];
          return { value: op[0] ? op[1] : void 0, done: true };
      }
  }
  var __createBinding = Object.create ? (function (o, m, k, k2) {
      if (k2 === undefined)
          k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m, k);
      if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
          desc = { enumerable: true, get: function () { return m[k]; } };
      }
      Object.defineProperty(o, k2, desc);
  }) : (function (o, m, k, k2) {
      if (k2 === undefined)
          k2 = k;
      o[k2] = m[k];
  });
  function __exportStar(m, o) {
      for (var p in m)
          if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
              __createBinding(o, m, p);
  }
  function __values(o) {
      var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
      if (m)
          return m.call(o);
      if (o && typeof o.length === "number")
          return {
              next: function () {
                  if (o && i >= o.length)
                      o = void 0;
                  return { value: o && o[i++], done: !o };
              }
          };
      throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
  }
  function __read(o, n) {
      var m = typeof Symbol === "function" && o[Symbol.iterator];
      if (!m)
          return o;
      var i = m.call(o), r, ar = [], e;
      try {
          while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
              ar.push(r.value);
      }
      catch (error) {
          e = { error: error };
      }
      finally {
          try {
              if (r && !r.done && (m = i["return"]))
                  m.call(i);
          }
          finally {
              if (e)
                  throw e.error;
          }
      }
      return ar;
  }
  /** @deprecated */
  function __spread() {
      for (var ar = [], i = 0; i < arguments.length; i++)
          ar = ar.concat(__read(arguments[i]));
      return ar;
  }
  /** @deprecated */
  function __spreadArrays() {
      for (var s = 0, i = 0, il = arguments.length; i < il; i++)
          s += arguments[i].length;
      for (var r = Array(s), k = 0, i = 0; i < il; i++)
          for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
              r[k] = a[j];
      return r;
  }
  function __spreadArray(to, from, pack) {
      if (pack || arguments.length === 2)
          for (var i = 0, l = from.length, ar; i < l; i++) {
              if (ar || !(i in from)) {
                  if (!ar)
                      ar = Array.prototype.slice.call(from, 0, i);
                  ar[i] = from[i];
              }
          }
      return to.concat(ar || Array.prototype.slice.call(from));
  }
  function __await(v) {
      return this instanceof __await ? (this.v = v, this) : new __await(v);
  }
  function __asyncGenerator(thisArg, _arguments, generator) {
      if (!Symbol.asyncIterator)
          throw new TypeError("Symbol.asyncIterator is not defined.");
      var g = generator.apply(thisArg, _arguments || []), i, q = [];
      return i = Object.create((typeof AsyncIterator === "function" ? AsyncIterator : Object).prototype), verb("next"), verb("throw"), verb("return", awaitReturn), i[Symbol.asyncIterator] = function () { return this; }, i;
      function awaitReturn(f) { return function (v) { return Promise.resolve(v).then(f, reject); }; }
      function verb(n, f) { if (g[n]) {
          i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); };
          if (f)
              i[n] = f(i[n]);
      } }
      function resume(n, v) { try {
          step(g[n](v));
      }
      catch (e) {
          settle(q[0][3], e);
      } }
      function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
      function fulfill(value) { resume("next", value); }
      function reject(value) { resume("throw", value); }
      function settle(f, v) { if (f(v), q.shift(), q.length)
          resume(q[0][0], q[0][1]); }
  }
  function __asyncDelegator(o) {
      var i, p;
      return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
      function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: false } : f ? f(v) : v; } : f; }
  }
  function __asyncValues(o) {
      if (!Symbol.asyncIterator)
          throw new TypeError("Symbol.asyncIterator is not defined.");
      var m = o[Symbol.asyncIterator], i;
      return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
      function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
      function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
  }
  function __makeTemplateObject(cooked, raw) {
      if (Object.defineProperty) {
          Object.defineProperty(cooked, "raw", { value: raw });
      }
      else {
          cooked.raw = raw;
      }
      return cooked;
  }
  ;
  var __setModuleDefault = Object.create ? (function (o, v) {
      Object.defineProperty(o, "default", { enumerable: true, value: v });
  }) : function (o, v) {
      o["default"] = v;
  };
  function __importStar(mod) {
      if (mod && mod.__esModule)
          return mod;
      var result = {};
      if (mod != null)
          for (var k in mod)
              if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                  __createBinding(result, mod, k);
      __setModuleDefault(result, mod);
      return result;
  }
  function __importDefault(mod) {
      return (mod && mod.__esModule) ? mod : { default: mod };
  }
  function __classPrivateFieldGet(receiver, state, kind, f) {
      if (kind === "a" && !f)
          throw new TypeError("Private accessor was defined without a getter");
      if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
          throw new TypeError("Cannot read private member from an object whose class did not declare it");
      return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
  }
  function __classPrivateFieldSet(receiver, state, value, kind, f) {
      if (kind === "m")
          throw new TypeError("Private method is not writable");
      if (kind === "a" && !f)
          throw new TypeError("Private accessor was defined without a setter");
      if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
          throw new TypeError("Cannot write private member to an object whose class did not declare it");
      return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
  }
  function __classPrivateFieldIn(state, receiver) {
      if (receiver === null || (typeof receiver !== "object" && typeof receiver !== "function"))
          throw new TypeError("Cannot use 'in' operator on non-object");
      return typeof state === "function" ? receiver === state : state.has(receiver);
  }
  function __addDisposableResource(env, value, async) {
      if (value !== null && value !== void 0) {
          if (typeof value !== "object" && typeof value !== "function")
              throw new TypeError("Object expected.");
          var dispose, inner;
          if (async) {
              if (!Symbol.asyncDispose)
                  throw new TypeError("Symbol.asyncDispose is not defined.");
              dispose = value[Symbol.asyncDispose];
          }
          if (dispose === void 0) {
              if (!Symbol.dispose)
                  throw new TypeError("Symbol.dispose is not defined.");
              dispose = value[Symbol.dispose];
              if (async)
                  inner = dispose;
          }
          if (typeof dispose !== "function")
              throw new TypeError("Object not disposable.");
          if (inner)
              dispose = function () { try {
                  inner.call(this);
              }
              catch (e) {
                  return Promise.reject(e);
              } };
          env.stack.push({ value: value, dispose: dispose, async: async });
      }
      else if (async) {
          env.stack.push({ async: true });
      }
      return value;
  }
  var _SuppressedError = typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
      var e = new Error(message);
      return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
  };
  function __disposeResources(env) {
      function fail(e) {
          env.error = env.hasError ? new _SuppressedError(e, env.error, "An error was suppressed during disposal.") : e;
          env.hasError = true;
      }
      var r, s = 0;
      function next() {
          while (r = env.stack.pop()) {
              try {
                  if (!r.async && s === 1)
                      return s = 0, env.stack.push(r), Promise.resolve().then(next);
                  if (r.dispose) {
                      var result = r.dispose.call(r.value);
                      if (r.async)
                          return s |= 2, Promise.resolve(result).then(next, function (e) { fail(e); return next(); });
                  }
                  else
                      s |= 1;
              }
              catch (e) {
                  fail(e);
              }
          }
          if (s === 1)
              return env.hasError ? Promise.reject(env.error) : Promise.resolve();
          if (env.hasError)
              throw env.error;
      }
      return next();
  }
  var tslib_es6 = {
      __extends: __extends,
      __assign: __assign,
      __rest: __rest,
      __decorate: __decorate,
      __param: __param,
      __metadata: __metadata,
      __awaiter: __awaiter,
      __generator: __generator,
      __createBinding: __createBinding,
      __exportStar: __exportStar,
      __values: __values,
      __read: __read,
      __spread: __spread,
      __spreadArrays: __spreadArrays,
      __spreadArray: __spreadArray,
      __await: __await,
      __asyncGenerator: __asyncGenerator,
      __asyncDelegator: __asyncDelegator,
      __asyncValues: __asyncValues,
      __makeTemplateObject: __makeTemplateObject,
      __importStar: __importStar,
      __importDefault: __importDefault,
      __classPrivateFieldGet: __classPrivateFieldGet,
      __classPrivateFieldSet: __classPrivateFieldSet,
      __classPrivateFieldIn: __classPrivateFieldIn,
      __addDisposableResource: __addDisposableResource,
      __disposeResources: __disposeResources,
  };

  var IPointerEvent = /** @class */ (function () {
      function IPointerEvent(event, target) {
          this.event = event;
          this.target = target;
          this.event = event;
      }
      Object.defineProperty(IPointerEvent.prototype, "originalEvent", {
          get: function () {
              return this.event;
          },
          enumerable: false,
          configurable: true
      });
      Object.defineProperty(IPointerEvent.prototype, "targetElement", {
          get: function () {
              return this.target || this.originalEvent.target;
          },
          enumerable: false,
          configurable: true
      });
      IPointerEvent.prototype.setTarget = function (target) {
          this.target = target;
      };
      IPointerEvent.prototype.preventDefault = function () {
          this.originalEvent.preventDefault();
      };
      Object.defineProperty(IPointerEvent.prototype, "isEventInLockedContext", {
          get: function () {
              return this.targetElement.closest('[fLockedContext]') !== null;
          },
          enumerable: false,
          configurable: true
      });
      return IPointerEvent;
  }());

  var IMouseEvent = /** @class */ (function (_super) {
      __extends(IMouseEvent, _super);
      function IMouseEvent(event, target) {
          return _super.call(this, event, target) || this;
      }
      IMouseEvent.prototype.isMouseLeftButton = function () {
          return this.originalEvent.button === 0;
      };
      IMouseEvent.prototype.isMouseRightButton = function () {
          return this.originalEvent.buttons === 2;
      };
      IMouseEvent.prototype.getPosition = function () {
          return { x: this.originalEvent.clientX, y: this.originalEvent.clientY };
      };
      return IMouseEvent;
  }(IPointerEvent));

  var ITouchDownEvent = /** @class */ (function (_super) {
      __extends(ITouchDownEvent, _super);
      function ITouchDownEvent(event) {
          return _super.call(this, event) || this;
      }
      ITouchDownEvent.prototype.isMouseLeftButton = function () {
          return true;
      };
      ITouchDownEvent.prototype.isMouseRightButton = function () {
          return false;
      };
      ITouchDownEvent.prototype.getPosition = function () {
          return { x: this.originalEvent.touches[0].clientX, y: this.originalEvent.touches[0].clientY };
      };
      return ITouchDownEvent;
  }(IPointerEvent));

  var ITouchMoveEvent = /** @class */ (function (_super) {
      __extends(ITouchMoveEvent, _super);
      function ITouchMoveEvent(event, target) {
          return _super.call(this, event, target) || this;
      }
      ITouchMoveEvent.prototype.isMouseLeftButton = function () {
          return true;
      };
      ITouchMoveEvent.prototype.isMouseRightButton = function () {
          return false;
      };
      ITouchMoveEvent.prototype.getPosition = function () {
          return { x: this.originalEvent.targetTouches[0].clientX, y: this.originalEvent.targetTouches[0].clientY };
      };
      return ITouchMoveEvent;
  }(IPointerEvent));

  var ITouchUpEvent = /** @class */ (function (_super) {
      __extends(ITouchUpEvent, _super);
      function ITouchUpEvent(event) {
          return _super.call(this, event) || this;
      }
      ITouchUpEvent.prototype.isMouseLeftButton = function () {
          return true;
      };
      ITouchUpEvent.prototype.isMouseRightButton = function () {
          return false;
      };
      ITouchUpEvent.prototype.getPosition = function () {
          return { x: this.originalEvent.changedTouches[0].clientX, y: this.originalEvent.changedTouches[0].clientY };
      };
      return ITouchUpEvent;
  }(IPointerEvent));

  var EventExtensions = /** @class */ (function () {
      function EventExtensions() {
      }
      EventExtensions.isPassiveEventListenerSupported = function () {
          if (EventExtensions.isSupported == null && typeof window !== 'undefined') {
              try {
                  window.addEventListener('test', EventExtensions.emptyListener, { passive: true });
                  EventExtensions.isSupported = true;
              }
              catch (e) {
                  EventExtensions.isSupported = false;
              }
          }
          return EventExtensions.isSupported;
      };
      EventExtensions.passiveEventListener = function (options) {
          return EventExtensions.isPassiveEventListenerSupported() ? options : !!options.capture;
      };
      EventExtensions.activeListener = function () {
          return EventExtensions.passiveEventListener({ passive: false });
      };
      EventExtensions.passiveListener = function () {
          return EventExtensions.passiveEventListener({ passive: true });
      };
      EventExtensions.emptyListener = function () {
          return function () {
          };
      };
      return EventExtensions;
  }());

  var MOUSE_EVENT_IGNORE_TIME = 800;
  var DragAndDropBase = /** @class */ (function () {
      function DragAndDropBase(ngZone) {
          var _this = this;
          this.ngZone = ngZone;
          this.mouseListeners = EventExtensions.emptyListener();
          this.touchListeners = EventExtensions.emptyListener();
          this.startListeners = EventExtensions.emptyListener();
          this.lastTouchEventTime = 0;
          this.isDragStarted = false;
          this.dragStartThreshold = 3;
          this.dragStartDelay = 0;
          this.dragStartTime = 0;
          this.dragStartPosition = { x: 0, y: 0 };
          this.moveHandler = this.checkDragSequenceToStart;
          this.pointerDownElement = null;
          this.onMouseDown = function (event) {
              var _a;
              var isSyntheticEvent = _this.isSyntheticEvent(event);
              var isFakeEvent = isFakeMousedownFromScreenReader(event);
              var mouseEvent = new IMouseEvent(event);
              _this.pointerDownElement = mouseEvent.targetElement;
              if (isSyntheticEvent || isFakeEvent || _this.disabled) {
                  return;
              }
              var result = _this.onPointerDown(mouseEvent);
              if (result) {
                  _this.dragStartTime = Date.now();
                  _this.dragStartPosition = mouseEvent.getPosition();
                  (_a = _this.ngZone) === null || _a === void 0 ? void 0 : _a.runOutsideAngular(function () {
                      var _a, _b, _c;
                      (_a = _this.document) === null || _a === void 0 ? void 0 : _a.addEventListener('selectstart', _this.onSelectStart, EventExtensions.activeListener());
                      (_b = _this.document) === null || _b === void 0 ? void 0 : _b.addEventListener('mousemove', _this.onMouseMove);
                      (_c = _this.document) === null || _c === void 0 ? void 0 : _c.addEventListener('mouseup', _this.onMouseUp);
                  });
                  _this.mouseListeners = function () {
                      var _a, _b, _c;
                      (_a = _this.document) === null || _a === void 0 ? void 0 : _a.removeEventListener('selectstart', _this.onSelectStart, EventExtensions.activeListener());
                      (_b = _this.document) === null || _b === void 0 ? void 0 : _b.removeEventListener('mousemove', _this.onMouseMove);
                      (_c = _this.document) === null || _c === void 0 ? void 0 : _c.removeEventListener('mouseup', _this.onMouseUp);
                  };
              }
          };
          this.onTouchDown = function (event) {
              var _a;
              var isFakeEvent = isFakeTouchstartFromScreenReader(event);
              var touchEvent = new ITouchDownEvent(event);
              _this.pointerDownElement = touchEvent.targetElement;
              if (isFakeEvent || _this.disabled) {
                  return;
              }
              var result = _this.onPointerDown(touchEvent);
              if (result) {
                  _this.dragStartTime = Date.now();
                  _this.dragStartPosition = touchEvent.getPosition();
                  (_a = _this.ngZone) === null || _a === void 0 ? void 0 : _a.runOutsideAngular(function () {
                      var _a, _b, _c;
                      (_a = _this.document) === null || _a === void 0 ? void 0 : _a.addEventListener('selectstart', _this.onSelectStart, EventExtensions.activeListener());
                      (_b = _this.document) === null || _b === void 0 ? void 0 : _b.addEventListener('touchmove', _this.onTouchMove);
                      (_c = _this.document) === null || _c === void 0 ? void 0 : _c.addEventListener('touchend', _this.onTouchUp);
                  });
                  _this.touchListeners = function () {
                      var _a, _b, _c;
                      (_a = _this.document) === null || _a === void 0 ? void 0 : _a.removeEventListener('selectstart', _this.onSelectStart, EventExtensions.activeListener());
                      (_b = _this.document) === null || _b === void 0 ? void 0 : _b.removeEventListener('touchmove', _this.onTouchMove);
                      (_c = _this.document) === null || _c === void 0 ? void 0 : _c.removeEventListener('touchend', _this.onTouchUp);
                  };
              }
          };
          this.onSelectStart = function (event) {
              _this.onSelect(event);
          };
          this.onMouseMove = function (event) {
              _this.moveHandler(new IMouseEvent(event));
          };
          this.onTouchMove = function (event) {
              _this.moveHandler(new ITouchMoveEvent(event));
          };
          this.onMouseUp = function (event) {
              if (_this.isDragStarted) {
                  _this.onPointerUp(new IMouseEvent(event));
              }
              _this.endDragSequence();
          };
          this.onTouchUp = function (event) {
              if (_this.isDragStarted) {
                  _this.onPointerUp(new ITouchUpEvent(event));
              }
              _this.endDragSequence();
          };
      }
      DragAndDropBase.prototype.isSyntheticEvent = function (event) {
          return !!this.lastTouchEventTime &&
              (this.lastTouchEventTime + MOUSE_EVENT_IGNORE_TIME > Date.now());
      };
      DragAndDropBase.prototype.checkDragSequenceToStart = function (event) {
          var pointerPosition = event.getPosition();
          if (!this.isDragStarted && this.pointerDownElement) {
              event.setTarget(this.pointerDownElement);
              var distanceX = Math.abs(pointerPosition.x - this.dragStartPosition.x);
              var distanceY = Math.abs(pointerPosition.y - this.dragStartPosition.y);
              var isOverThreshold = distanceX + distanceY >= this.dragStartThreshold;
              if (isOverThreshold) {
                  var isDelayElapsed = Date.now() >= this.dragStartTime + this.dragStartDelay;
                  if (!isDelayElapsed) {
                      this.endDragSequence();
                      return;
                  }
                  event.preventDefault();
                  this.prepareDragSequence(event);
                  this.isDragStarted = true;
                  this.moveHandler = this.onPointerMove;
                  if (isTouchEvent(event.originalEvent)) {
                      this.lastTouchEventTime = Date.now();
                  }
              }
          }
      };
      DragAndDropBase.prototype.endDragSequence = function () {
          this.isDragStarted = false;
          this.pointerDownElement = null;
          this.moveHandler = this.checkDragSequenceToStart;
          this.mouseListeners();
          this.mouseListeners = EventExtensions.emptyListener();
          this.touchListeners();
          this.touchListeners = EventExtensions.emptyListener();
          this.finalizeDragSequence();
      };
      DragAndDropBase.prototype.subscribe = function (fDocument) {
          var _this = this;
          var _a;
          if (this.document) {
              this.unsubscribe();
          }
          this.document = fDocument;
          (_a = this.ngZone) === null || _a === void 0 ? void 0 : _a.runOutsideAngular(function () {
              fDocument.addEventListener('mousedown', _this.onMouseDown, EventExtensions.activeListener());
              fDocument.addEventListener('touchstart', _this.onTouchDown, EventExtensions.passiveListener());
          });
          this.startListeners = function () {
              fDocument.removeEventListener('mousedown', _this.onMouseDown, EventExtensions.activeListener());
              fDocument.removeEventListener('touchstart', _this.onTouchDown, EventExtensions.passiveListener());
          };
      };
      DragAndDropBase.prototype.unsubscribe = function () {
          this.startListeners();
          this.startListeners = EventExtensions.emptyListener();
          this.touchListeners();
          this.touchListeners = EventExtensions.emptyListener();
          this.mouseListeners();
          this.mouseListeners = EventExtensions.emptyListener();
      };
      return DragAndDropBase;
  }());
  function isTouchEvent(event) {
      return event.type[0] === 't';
  }
  function isFakeMousedownFromScreenReader(event) {
      return event.buttons === 0 || (event.offsetX === 0 && event.offsetY === 0);
  }
  function isFakeTouchstartFromScreenReader(event) {
      var touch = (event.touches && event.touches[0]) || (event.changedTouches && event.changedTouches[0]);
      return (!!touch &&
          touch.identifier === -1 &&
          (touch.radiusX == null || touch.radiusX === 1) &&
          (touch.radiusY == null || touch.radiusY === 1));
  }

  /**
   * Generated bundle index. Do not edit.
   */

  exports.DragAndDropBase = DragAndDropBase;
  exports.EventExtensions = EventExtensions;
  exports.IMouseEvent = IMouseEvent;
  exports.IPointerEvent = IPointerEvent;
  exports.ITouchDownEvent = ITouchDownEvent;
  exports.ITouchMoveEvent = ITouchMoveEvent;
  exports.ITouchUpEvent = ITouchUpEvent;
  exports.MOUSE_EVENT_IGNORE_TIME = MOUSE_EVENT_IGNORE_TIME;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=foblex-drag-toolkit.umd.js.map
