export declare abstract class IPointerEvent {
    private readonly event;
    private target?;
    get originalEvent(): (MouseEvent | TouchEvent);
    get targetElement(): HTMLElement;
    protected constructor(event: (MouseEvent | TouchEvent), target?: HTMLElement | undefined);
    setTarget(target: HTMLElement): void;
    abstract isMouseLeftButton(): boolean;
    abstract isMouseRightButton(): boolean;
    preventDefault(): void;
    abstract getPosition(): {
        x: number;
        y: number;
    };
    get isEventInLockedContext(): boolean;
}
